import React, { useEffect } from 'react';
import useGoogleAnalytics from './useGoogleAnalytics';

type Props = {};

const GoogleAnalytics = (props: Props) => {
  const { GA_TRACKING_ID, event, pageview } = useGoogleAnalytics();

  useEffect(() => {
    const gtagScript = document.createElement('script');
    gtagScript.src = `https://www.googletagmanager.com/gtag/js?id=${GA_TRACKING_ID}`;
    document.body.appendChild(gtagScript);

    const initScript = document.createElement('script');
    initScript.innerHTML = `
      window.dataLayer = window.dataLayer || [];
      function gtag(){dataLayer.push(arguments);}
      gtag('js', new Date());
      gtag('config', '${GA_TRACKING_ID}', {
        page_path: window.location.pathname,
      });
    `;
    document.body.appendChild(initScript);

    // cleanup on unmount
    return () => {
      document.body.removeChild(gtagScript);
      document.body.removeChild(initScript);
    };
  }, []);

  return null;
};

export default GoogleAnalytics;
